/* 
 * Based on f2a by Ulrich Hecht <uli@emulinks.de>
 * if2a patch by D. Gauchard <deyv@free.fr>
 * F2A Ultra support by Vincent Rubiolo <vincent.rubiolo@free.fr>
 * Licensed under the terms of the GNU Public License version 2
 */
 
// Cart/ROM functions header file

#ifndef __F2ACARTS_H__
#define __F2ACARTS_H__
#include "topheader.h"
#include "libf2a.h"

//////////////////////////////////////

extern int	f2a_rom_block_size_log2;	// log2(f2a_rom_block_size) - roms have to have a size multiple of f2a_rom_block_size
extern int	f2a_write_block_size_log2;	// log2(f2a_write_block_size) - minimum block size to write on cart
extern int	f2a_cartsize_mb; 		// cart size in Mbits. Now set by f2a_get_type()
extern int	f2a_thorough_comp;
extern int	f2a_use_loader;
extern int	f2a_correct_header_allowed;
extern int	f2a_force_burn;
extern int	f2a_reduce_forced;
extern int	f2a_reduce_allowed;

int     select_loader           (enum cart_type_e cart_type, char* loader_file);
int	trim			(char* rom, int size);
int     has_good_header         (unsigned char* rom);
void    correct_header          (unsigned char* rom, unsigned char* name, int force_correction, int force_name);
void    display_map             (unsigned char* rom);
int     old_display_cart_map	(void);
void    auto_readandsave_rom    (int numfiles, char** files);
void    display_memory_map      (unsigned char* rom, int size);
int     is_same                 (int offset, int size, unsigned char* mem);
int     has_same_data           (int offset, int size, unsigned char* mem);
int     convsize                (char* size);
int     convf2ablock            (char* block, int* offset, int* size);
int     get_wholesize           (int numfiles, char** files);
int     f2apro_loadandwrite_sram(char* file, int offset, int size);
char*   prepare_loadandwrite_sram(char* file, int offset, int size);
int     auto_loadandburn_rom    (enum cart_type_e cart_type, int clean_rom, int numfiles, char** files);
unsigned char* romname          (unsigned char* rom);
unsigned char* filename2romname	(unsigned char* filename);
void    adjust_burn_addresses   (int* offset, int* size);
void	adjust_rom_addresses	(int* offset, int* size);
void	adjust_load_addresses	(int* offset, int* size);
void    adjust_rom_size         (int* size);
void    adjust_write_size       (int* size);

#endif // __F2ACARTS_H__
