/* 
 * Based on f2a by Ulrich Hecht <uli@emulinks.de>
 * if2a patch by D. Gauchard <deyv@free.fr>
 * F2A Ultra support by Vincent Rubiolo <vincent.rubiolo@free.fr>
 * Licensed under the terms of the GNU Public License version 2
 */
 
// USB-related header
#ifndef __F2AUSB_H__
#define __F2AUSB_H__
#include "topheader.h"

#include <usb.h>

/* 
 * USB timeouts. f2a_usb_timeout as globlal so that the routines can tweak it
 * depending on their needs
 * Default value is USB_TIMEOUT
 */
#define USB_TIMEOUT			8000
extern int f2a_usb_timeout;

usb_dev_handle*	f2a_usb_open		(struct usb_device* dev, int init_hack);
int	 	f2a_usb_connect 	(void);
void		f2a_usb_disconnect 	(void);
void		f2a_usb_exit 		(int status);
int		f2a_usb_read 		(char *buffer, int buffer_size);
int		f2a_usb_write		(char *buffer, int buffer_size);
int		f2a_usb_write_by_block 	(char* buffer, int buffer_size, int block_size);

#endif // __F2AUSB_H__
